UESTC1225 题解

题意:某公寓有N层楼,每层楼有Pi个游泳爱好者和Ti个乒乓球爱好者,每层楼只能建一个游泳池或者一个乒乓球场,求所有人到其运动场所的最短距离之和(两层楼之间距离为1)

2<=N<=4000,1<=Pi,Ti<=109.1~100组数据,4000MS

题解:DP[i][j][0~1]分别表示第i层建乒乓球场,游泳场,且前一个和该处运动场所不同的位置为j,通过预处理完成O(1)转移,总复杂度为O(N2)

使用滚动数组,单独考虑来自DP[i-1][0][0~1]的转移

预处理内容:前缀和S,S2[i]=∑S[j]*j*2(1<=j<=i),前缀和的前缀和(不必要)

#include<cstdio>
#include<cstring>
#include<iostream>
using namespace std;

const long long inf=100000000000000000;
const int maxn=4200;
int tt,n,now;
long long t[maxn],p[maxn],sx[maxn],sy[maxn],s2x[maxn],s2y[maxn],s0x[maxn],s0y[maxn];
long long dp[2][maxn][2];
long long ans;

int main(){
    //freopen("K.in","r",stdin);
    //freopen("K.out","w",stdout);
    scanf("%d",&tt);
    for (int q=1;q<=tt;++q){
        scanf("%d",&n);
        sx[0]=0;sy[0]=0;s2x[0]=0;s2y[0]=0;s0x[0]=0;s0y[0]=0;
        for (int i=1;i<=n;++i) {scanf("%d%d",&t[i],&p[i]);sx[i]=sx[i-1]+t[i];sy[i]=sy[i-1]+p[i];s0x[i]=s0x[i-1]+sx[i];s0y[i]=s0y[i-1]+sy[i];}
        for (int i=1;i<=n;++i) {s2x[i]=s2x[i-1]+t[i]*2*i;s2y[i]=s2y[i-1]+p[i]*2*i;}
        memset(dp,0,sizeof(dp));
        now=1;
        for (int i=2;i<=n;++i){
            for (int j=1;j<=i-2;++j) dp[now][j][0]=dp[now^1][j][0]+p[i]*(i-j);
            dp[now][i-1][0]=s0x[i-1]+p[i];
            for (int j=1;j<=i-2;++j) dp[now][i-1][0]=min(dp[now][i-1][0],dp[now^1][j][1]+p[i]-(s2x[i-1]-s2x[(i-1+j)/2]-(sx[i-1]-sx[(i-1+j)/2])*(i+j)));
            for (int j=0;j<=i-2;++j) dp[now][j][1]=dp[now^1][j][1]+t[i]*(i-j);
            dp[now][i-1][1]=s0y[i-1]+t[i];
            for (int j=1;j<=i-2;++j) dp[now][i-1][1]=min(dp[now][i-1][1],dp[now^1][j][0]+t[i]-(s2y[i-1]-s2y[(i-1+j)/2]-(sy[i-1]-sy[(i-1+j)/2])*(i+j)));
            now=now^1;
        }
        now=now^1;
        ans=inf;
        for (int i=1;i<=n-1;++i) {ans=min(ans,dp[now][i][1]),ans=min(ans,dp[now][i][0]);}
        cout<<"Case #"<<q<<": "<<ans<<endl;
    }
    return 0;
}
时间: 2024-10-10 17:48:27

UESTC1225 题解的相关文章

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ

HDU 1045 Fire Net 二分图Bipartite题解

本题可以使用DFS直接爆搜出答案,不过这样类型的题目其实是个二分图的题解. 这个二分图,难不在Hungary算法,而是难在于建图.需要挺高的抽象思维的. 建图: 1 把同一行不被X分开的格子标同一个号码,被X分开的标下一个号码,这样做是为了缩点,不需要把所有的格子都分开标号,而且可以更方便建个更加小的图. 2 同理把同一列的格子标号 3 然后判断相同一个格子的行标号和列标号是有路径的,其他不在同一个格子的都是没有路径的. 4 这样就等于以行标号和列标号作为左右顶点,构建成一个二分图了 然后使用H